# build/parsePreamble.c File Reference

Parse tags in global section from spec file. More...

`#include "system.h"`
`#include <rpmio_internal.h>`
`#include <rpmbuild.h>`
`#include "debug.h"`

Go to the source code of this file.

## Data Structures

struct | tokenBits_s
struct | optionalTag
struct | PreambleRec_s

## Defines

#define | SINGLE_TOKEN_ONLY

## Typedefs

typedef tokenBits_s * | tokenBits
typedef PreambleRec_s * | PreambleRec

## Functions

static void | addOrAppendListEntry (Header h, int_32 tag, char *line)
static int | parseSimplePart (char *line, char **name, int *flag)
static int | parseYesNo (const char *s)
static int | parseBits (const char *s, const tokenBits tokbits, rpmsenseFlags *bp)
static char * | findLastChar (char *s)
static int | isMemberInEntry (Header h, const char *name, rpmTag tag)
static int | checkForValidArchitectures (Spec spec)
static int | checkForRequired (Header h, const char *NVR)
| Check that required tags are present in header.
static int | checkForDuplicates (Header h, const char *NVR)
| Check that no duplicate tags are present in header.
static void | fillOutMainPackage (Header h)
static int | readIcon (Header h, const char *file)
spectag | stashSt (Spec spec, Header h, int tag, const char *lang)
static int | handlePreambleTag (Spec spec, Package pkg, int tag, const char *macro, const char *lang)
static void | initPreambleList (void)
static int | findPreambleTag (Spec spec, int *tag, const char **macro, char *lang)
int | parsePreamble (Spec spec, int initialPackage)
| Parse tags from preamble of a spec file.

## Variables

static rpmTag | copyTagsDuringParse []
static rpmTag | requiredTags []
static struct tokenBits_s | installScriptBits []
static struct tokenBits_s | buildScriptBits []
static struct optionalTag | optionalTags []
int | noLang
static struct PreambleRec_s | preambleList []

## Detailed Description

Parse tags in global section from spec file.

Definition in file parsePreamble.c.

## Define Documentation

#define SINGLE_TOKEN_ONLY

Value:

    if (multiToken) { \
        rpmError(RPMERR_BADSPEC, _("line %d: Tag takes single token only: %s\n"), \
                 spec->lineNum, spec->line); \
        return RPMERR_BADSPEC; \
    }

Definition at line 432 of file parsePreamble.c.

Referenced by handlePreambleTag().

## Typedef Documentation

typedef struct PreambleRec_s * PreambleRec

typedef struct tokenBits_s * tokenBits

## Function Documentation

static void addOrAppendListEntry | ( | Header | h,
|  | int_32 | tag,
|  | char * | line |
| ) |  |  | `[static]`

Definition at line 51 of file parsePreamble.c.

References _free(), headerAddOrAppendEntry(), poptParseArgvString(), and RPM_STRING_ARRAY_TYPE.

Referenced by handlePreambleTag().

static int checkForDuplicates | ( | Header | h,
|  | const char * | NVR |
| ) |  |  | `[static]`

Check that no duplicate tags are present in header.

Parameters:

  | h | header
  | NVR | package name-version-release

Returns:
  0 if OK

Definition at line 286 of file parsePreamble.c.

References _, headerFreeIterator(), headerInitIterator(), headerNextIterator(), RPMERR_BADSPEC, rpmError, and tagName().

Referenced by parsePreamble().

static int checkForRequired | ( | Header | h,
|  | const char * | NVR |
| ) |  |  | `[static]`

Check that required tags are present in header.

Parameters:

  | h | header
  | NVR | package name-version-release

Returns:
  0 if OK

Definition at line 262 of file parsePreamble.c.

References _, headerIsEntry(), requiredTags, RPMERR_BADSPEC, rpmError, and tagName().

Referenced by parsePreamble().

static int checkForValidArchitectures | ( | Spec | spec | ) | `[static]`

Definition at line 218 of file parsePreamble.c.

References _, SpecStruct::buildRestrictions, isMemberInEntry(), RPMERR_BADSPEC, rpmError, rpmExpand(), rpmGetArchInfo(), rpmGetOsInfo(), RPMTAG_EXCLUDEARCH, RPMTAG_EXCLUDEOS, RPMTAG_EXCLUSIVEARCH, and RPMTAG_EXCLUSIVEOS.

Referenced by parsePreamble().

static void fillOutMainPackage | ( | Header | h | ) | `[static]`

Definition at line 324 of file parsePreamble.c.

References _free(), headerAddEntry(), headerIsEntry(), optionalTags, optionalTag::ot_mac, optionalTag::ot_tag, RPM_STRING_TYPE, and rpmExpand().

Referenced by parsePreamble().

static char* findLastChar | ( | char * | s | ) | `[inline, static]`

Definition at line 179 of file parsePreamble.c.

References xisspace().

Referenced by handlePreambleTag().

static int findPreambleTag | ( | Spec | spec,
|  | int * | tag,
|  | const char ** | macro,
|  | char * | lang |
| ) |  |  | `[static]`

Definition at line 779 of file parsePreamble.c.

References initPreambleList(), PreambleRec_s::len, SpecStruct::line, PreambleRec_s::multiLang, preambleList, RPMTAG_PATCH, RPMTAG_SOURCE, SKIPSPACE, PreambleRec_s::tag, PreambleRec_s::token, and xstrncasecmp().

Referenced by parsePreamble().

static int handlePreambleTag | ( | Spec | spec,
|  | Package | pkg,
|  | int | tag,
|  | const char * | macro,
|  | const char * | lang |
| ) |  |  | `[static]`

Definition at line 445 of file parsePreamble.c.

References _, _free(), addMacro(), addOrAppendListEntry(), addSource(), PackageStruct::autoProv, PackageStruct::autoReq, SpecStruct::BACount, SpecStruct::BANames, SpecStruct::buildRestrictions, SpecStruct::buildRootURL, buildScriptBits, delMacro(), findLastChar(), SpecStruct::gotBuildRootURL, PackageStruct::header, headerAddEntry(), headerAddI18NString(), headerFreeData(), headerGetEntryMinMemory(), installScriptBits, SpecStruct::line, SpecStruct::lineNum, SpecStruct::macros, noLang, SpecStruct::noSource, parseBits(), parseNoSource(), parseNum(), parseRCPOT(), parseYesNo(), poptParseArgvString(), readIcon(), RMIL_OLDSPEC, RMIL_SPEC, SpecStruct::rootURL, RPM_INT32_TYPE, RPM_STRING_TYPE, RPMBUILD_DEFAULT_LANG, RPMERR_BADSPEC, RPMERR_INTERNAL, rpmError, rpmGenPath(), RPMSENSE_ANY, RPMTAG_AUTOPROV, RPMTAG_AUTOREQ, RPMTAG_AUTOREQPROV, RPMTAG_BUILDARCHS, RPMTAG_BUILDCONFLICTS, RPMTAG_BUILDPREREQ, RPMTAG_BUILDREQUIRES, RPMTAG_BUILDROOT, RPMTAG_CONFLICTFLAGS, RPMTAG_DISTRIBUTION, RPMTAG_DOCDIR, RPMTAG_EPOCH, RPMTAG_EXCLUDEARCH, RPMTAG_EXCLUDEOS, RPMTAG_EXCLUSIVEARCH, RPMTAG_EXCLUSIVEOS, RPMTAG_GROUP, RPMTAG_ICON, RPMTAG_LICENSE, RPMTAG_NAME, RPMTAG_NOPATCH, RPMTAG_NOSOURCE, RPMTAG_OBSOLETEFLAGS, RPMTAG_PACKAGER, RPMTAG_PATCH, RPMTAG_PREFIXES, RPMTAG_PREREQ, RPMTAG_PROVIDEFLAGS, RPMTAG_RELEASE, RPMTAG_REQUIREFLAGS, RPMTAG_RHNPLATFORM, RPMTAG_SOURCE, RPMTAG_SUMMARY, RPMTAG_URL, RPMTAG_VENDOR, RPMTAG_VERSION, SINGLE_TOKEN_ONLY, SKIPNONSPACE, SKIPSPACE, stashSt(), tagName(), and urlPath().

Referenced by parsePreamble().

static void initPreambleList | ( | void |  | ) | `[inline, static]`

Definition at line 768 of file parsePreamble.c.

References PreambleRec_s::len, preambleList, and PreambleRec_s::token.

Referenced by findPreambleTag().

static int isMemberInEntry | ( | Header | h,
|  | const char * | name,
|  | rpmTag | tag |
| ) |  |  | `[static]`

Definition at line 197 of file parsePreamble.c.

References headerFreeData(), headerGetEntryMinMemory(), and xstrcasecmp().

Referenced by checkForValidArchitectures().

static int parseBits | ( | const char * | s,
|  | const tokenBits | tokbits,
|  | rpmsenseFlags * | bp |
| ) |  |  | `[static]`

Definition at line 143 of file parsePreamble.c.

References tokenBits_s::bits, tokenBits_s::name, RPMERR_BADSPEC, RPMSENSE_ANY, xisalpha(), and xisspace().

Referenced by handlePreambleTag().

static int parseSimplePart | ( | char * | line,
|  | char ** | name,
|  | int * | flag |
| ) |  |  | `[static]`

Definition at line 69 of file parsePreamble.c.

References PART_NAME, and PART_SUBNAME.

Referenced by parsePreamble().

static int parseYesNo | ( | const char * | s | ) | `[inline, static]`

Definition at line 102 of file parsePreamble.c.

References xstrcasecmp().

Referenced by handlePreambleTag().

static int readIcon | ( | Header | h,
|  | const char * | file |
| ) |  |  | `[static]`

Definition at line 342 of file parsePreamble.c.

References _, _free(), Fclose(), fdSize(), Ferror(), Fopen(), Fread(), Fstrerror(), headerAddEntry(), RPM_BIN_TYPE, RPMERR_BADSPEC, rpmError, rpmGetPath(), RPMTAG_GIF, RPMTAG_XPM, and xmalloc().

Referenced by handlePreambleTag().

## Variable Documentation

struct tokenBits_s buildScriptBits[]`[static]`

Initial value:

     {
        { "prep",           RPMSENSE_SCRIPT_PREP },
        { "build",          RPMSENSE_SCRIPT_BUILD },
        { "install",        RPMSENSE_SCRIPT_INSTALL },
        { "clean",          RPMSENSE_SCRIPT_CLEAN },
        { NULL, 0 }
    }

Definition at line 133 of file parsePreamble.c.

Referenced by handlePreambleTag().

rpmTag copyTagsDuringParse[]`[static]`

Initial value:

     {
        RPMTAG_EPOCH,
        RPMTAG_VERSION,
        RPMTAG_RELEASE,
        RPMTAG_LICENSE,
        RPMTAG_PACKAGER,
        RPMTAG_DISTRIBUTION,
        RPMTAG_DISTURL,
        RPMTAG_VENDOR,
        RPMTAG_ICON,
        RPMTAG_URL,
        RPMTAG_CHANGELOGTIME,
        RPMTAG_CHANGELOGNAME,
        RPMTAG_CHANGELOGTEXT,
        RPMTAG_PREFIXES,
        RPMTAG_RHNPLATFORM,
        0
    }

Definition at line 17 of file parsePreamble.c.

Referenced by parsePreamble().

struct tokenBits_s installScriptBits[]`[static]`

Initial value:

     {
        { "interp",         RPMSENSE_INTERP },
        { "prereq",         RPMSENSE_PREREQ },
        { "preun",          RPMSENSE_SCRIPT_PREUN },
        { "pre",            RPMSENSE_SCRIPT_PRE },
        { "postun",         RPMSENSE_SCRIPT_POSTUN },
        { "post",           RPMSENSE_SCRIPT_POST },
        { "rpmlib",         RPMSENSE_RPMLIB },
        { "verify",         RPMSENSE_SCRIPT_VERIFY },
        { NULL, 0 }
    }

Definition at line 118 of file parsePreamble.c.

Referenced by handlePreambleTag().

int noLang

Definition at line 59 of file poptBT.c.

struct optionalTag optionalTags[]`[static]`

Referenced by fillOutMainPackage().

struct PreambleRec_s preambleList[]`[static]`

Definition at line 719 of file parsePreamble.c.

Referenced by findPreambleTag(), and initPreambleList().

rpmTag requiredTags[]`[static]`

Initial value:

     {
        RPMTAG_NAME,
        RPMTAG_VERSION,
        RPMTAG_RELEASE,
        RPMTAG_SUMMARY,
        RPMTAG_GROUP,
        RPMTAG_LICENSE,
        0
    }

Definition at line 39 of file parsePreamble.c.

Referenced by checkForRequired().